diff --git a/util/nbt/src/test/java/TestNbtIo.java b/util/nbt/src/test/java/TestNbtIo.java
new file mode 100644
index 000000000..3ba692855
--- /dev/null
+++ b/util/nbt/src/test/java/TestNbtIo.java
@@ -0,0 +1,306 @@
+import com.mojang.nbt.NbtIo;
+import com.mojang.nbt.tags.ByteArrayTag;
+import com.mojang.nbt.tags.ByteTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.DoubleArrayTag;
+import com.mojang.nbt.tags.DoubleTag;
+import com.mojang.nbt.tags.FloatTag;
+import com.mojang.nbt.tags.IntTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.LongArrayTag;
+import com.mojang.nbt.tags.LongTag;
+import com.mojang.nbt.tags.ShortArrayTag;
+import com.mojang.nbt.tags.ShortTag;
+import com.mojang.nbt.tags.StringTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.DisplayName;
+import org.junit.jupiter.api.Test;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.File;
+import java.io.IOException;
+import java.nio.file.Files;
+
+public class TestNbtIo {
+    @Test
+    @DisplayName("Read Compressed Example NBT files")
+    public void readCompressedExamples() {
+        try {
+            CompoundTag exampleData = NbtIo.readCompressed(TestNbtIo.class.getResourceAsStream("/examples/compressed/helloWorld.dat"));
+            CompoundTag expected = new CompoundTag();
+            expected.putString("Hello", "World!");
+
+            Assertions.assertEquals(expected, exampleData);
+        } catch (IOException e) {
+            Assertions.fail("Failed to read compressed example tag 'helloWorld.dat'", e);
+        }
+
+        try {
+            CompoundTag exampleData = NbtIo.readCompressed(TestNbtIo.class.getResourceAsStream("/examples/compressed/allTags_1_0_0.dat"));
+            CompoundTag expected = new CompoundTag();
+            expected.put("String", new StringTag("String"));
+            expected.put("Byte", new ByteTag(Byte.MAX_VALUE));
+            expected.put("Short", new ShortTag(Short.MAX_VALUE));
+            expected.put("Int", new IntTag(Integer.MAX_VALUE));
+            expected.put("Long", new LongTag(Long.MAX_VALUE));
+            expected.put("Float", new FloatTag(Float.MAX_VALUE));
+            expected.put("Double", new DoubleTag(Double.MAX_VALUE));
+            expected.put("ByteArray", new ByteArrayTag(new byte[]{Byte.MIN_VALUE, 0, Byte.MAX_VALUE}));
+            expected.put("ShortArray", new ShortArrayTag(new short[]{Short.MIN_VALUE, 0, Short.MAX_VALUE}));
+            expected.put("DoubleArray", new DoubleArrayTag(new double[]{Double.NaN, Double.NEGATIVE_INFINITY, Double.MIN_VALUE, 0, Double.MAX_VALUE, Double.POSITIVE_INFINITY}));
+
+            ListTag listTag = new ListTag();
+            listTag.addTag(new IntTag(0));
+            listTag.addTag(new IntTag(1));
+            listTag.addTag(new IntTag(2));
+            listTag.addTag(new IntTag(3));
+            listTag.addTag(new IntTag(4));
+            expected.put("List", listTag);
+
+            Assertions.assertEquals(expected, exampleData);
+        } catch (IOException e) {
+            Assertions.fail("Failed to read compressed example tag 'allTags_1_0_0.dat'", e);
+        }
+
+        try {
+            CompoundTag exampleData = NbtIo.readCompressed(TestNbtIo.class.getResourceAsStream("/examples/compressed/level.dat"));
+            CompoundTag expected = new CompoundTag();
+            CompoundTag Data = new CompoundTag();
+
+            {
+                CompoundTag GameRules = new CompoundTag();
+                GameRules.putBoolean("allowSleeping", true);
+                GameRules.putBoolean("allowSprinting", false);
+                GameRules.putBoolean("doDaylightCycle", true);
+                GameRules.putBoolean("doNightmares", true);
+                GameRules.putBoolean("doSeasonalGrowth", true);
+                GameRules.putBoolean("dwarfMode", false);
+                GameRules.putBoolean("instantHealing", false);
+                GameRules.putBoolean("keepInventory", false);
+                GameRules.putBoolean("mobGriefing", true);
+                GameRules.putBoolean("treecapitator", false);
+                Data.put("GameRules", GameRules);
+            }
+
+            {
+                CompoundTag Player = new CompoundTag();
+
+                ListTag Motion = new ListTag();
+                Motion.addTag(new DoubleTag(-3.693745721752247E-08D));
+                Motion.addTag(new DoubleTag(-0.0784D));
+                Motion.addTag(new DoubleTag(-3.1104333276149703E-08D));
+                Player.put("Motion", Motion);
+
+                ListTag Pos = new ListTag();
+                Pos.addTag(new DoubleTag(-255.1804810773446));
+                Pos.addTag(new DoubleTag(157.62000000476837));
+                Pos.addTag(new DoubleTag(-251.93904820770453));
+                Player.put("Pos", Pos);
+
+                ListTag Rotation = new ListTag();
+                Rotation.addTag(new FloatTag(108.19741F));
+                Rotation.addTag(new FloatTag(9.819301F));
+                Player.put("Rotation", Rotation);
+
+                Player.putShort("Air", (short) 300);
+                Player.putShort("AttackTime", (short) 0);
+                Player.putByte("ChatColor", (byte) 0);
+                Player.putShort("DeathTime", (short) 0);
+                Player.putInt("Dimension", 0);
+                Player.putFloat("FallDistance", 0);
+                Player.putShort("Fire", (short) -20);
+                Player.putInt("Gamemode", 0);
+                Player.putShort("Health", (short) 9);
+                Player.putShort("HurtTime", (short) 0);
+                Player.putString("Nickname", "");
+                Player.putBoolean("Noclip", false);
+                Player.putBoolean("OnGround", true);
+                Player.putInt("Score", 29750);
+                Player.putByte("SkinVariant", (byte) 59);
+                Player.putBoolean("Sleeping", false);
+                Player.putShort("SleepTimer", (short) 0);
+                Player.putInt("SpawnX", -249);
+                Player.putInt("SpawnY", 163);
+                Player.putInt("SpawnZ", -251);
+
+                Data.put("Player", Player);
+            }
+
+            Data.putBoolean("CheatsEnabled", false);
+            Data.putLong("LastPlayed", 1722422564254L);
+            Data.putString("LevelName", "7.2 World");
+            Data.putLong("RandomSeed", -3160577061770148618L);
+            Data.putLong("SizeOnDisk", 23212032L);
+            Data.putInt("SpawnX", -191);
+            Data.putInt("SpawnY", 129);
+            Data.putInt("SpawnZ", -391);
+            Data.putLong("Time", 189025L);
+            Data.putInt("version", 19134);
+
+            expected.put("Data", Data);
+
+            Assertions.assertEquals(expected, exampleData);
+        } catch (IOException e) {
+            Assertions.fail("Failed to read compressed example tag 'level.dat'!", e);
+        }
+
+        try {
+            CompoundTag exampleData = NbtIo.readCompressed(TestNbtIo.class.getResourceAsStream("/examples/compressed/dimension.dat"));
+            CompoundTag expected = new CompoundTag();
+            CompoundTag Data = new CompoundTag();
+
+            {
+                CompoundTag Weather = new CompoundTag();
+                Weather.putInt("CurrentID", 1);
+                Weather.putLong("Duration", 3082);
+                Weather.putFloat("Intensity", 1);
+                Weather.putInt("NextID", -1);
+                Weather.putFloat("Power", 0.8544321F);
+                Data.put("Weather", Weather);
+            }
+
+            Data.putString("WorldType", "minecraft:overworld.extended");
+            expected.put("Data", Data);
+
+            Assertions.assertEquals(expected, exampleData);
+        } catch (IOException e) {
+            Assertions.fail("Failed to read compressed example tag 'dimension.dat'!", e);
+        }
+    }
+
+    @Test
+    @DisplayName("readUncompressedExamples")
+    public void readUncompressedExamples() {
+        try {
+            CompoundTag exampleData = NbtIo.read(new DataInputStream(TestNbtIo.class.getResourceAsStream("/examples/uncompressed/helloWorld.dat")));
+            CompoundTag expected = new CompoundTag();
+            expected.putString("Hello", "World!");
+
+            Assertions.assertEquals(expected, exampleData);
+        } catch (IOException e) {
+            Assertions.fail("Failed to read uncompressed example tag 'helloWorld.dat'", e);
+        }
+
+        try {
+            CompoundTag exampleData = NbtIo.read(new DataInputStream(TestNbtIo.class.getResourceAsStream("/examples/uncompressed/allTags_1_0_0.dat")));
+            CompoundTag expected = new CompoundTag();
+            expected.put("String", new StringTag("String"));
+            expected.put("Byte", new ByteTag(Byte.MAX_VALUE));
+            expected.put("Short", new ShortTag(Short.MAX_VALUE));
+            expected.put("Int", new IntTag(Integer.MAX_VALUE));
+            expected.put("Long", new LongTag(Long.MAX_VALUE));
+            expected.put("Float", new FloatTag(Float.MAX_VALUE));
+            expected.put("Double", new DoubleTag(Double.MAX_VALUE));
+            expected.put("ByteArray", new ByteArrayTag(new byte[]{Byte.MIN_VALUE, 0, Byte.MAX_VALUE}));
+            expected.put("ShortArray", new ShortArrayTag(new short[]{Short.MIN_VALUE, 0, Short.MAX_VALUE}));
+            expected.put("DoubleArray", new DoubleArrayTag(new double[]{Double.NaN, Double.NEGATIVE_INFINITY, Double.MIN_VALUE, 0, Double.MAX_VALUE, Double.POSITIVE_INFINITY}));
+
+            ListTag listTag = new ListTag();
+            listTag.addTag(new IntTag(0));
+            listTag.addTag(new IntTag(1));
+            listTag.addTag(new IntTag(2));
+            listTag.addTag(new IntTag(3));
+            listTag.addTag(new IntTag(4));
+            expected.put("List", listTag);
+
+            Assertions.assertEquals(expected, exampleData);
+        } catch (IOException e) {
+            Assertions.fail("Failed to read uncompressed example tag 'allTags_1_0_0.dat'", e);
+        }
+    }
+
+    @SuppressWarnings("ResultOfMethodCallIgnored")
+    @Test
+    @DisplayName("Test NBT read back")
+    public void ioTest() {
+        File out = new File("./testWork");
+        out.mkdirs();
+        File fileOut = new File(out, "test.dat");
+        {
+
+            CompoundTag dataTag = new CompoundTag();
+            dataTag.putString("Hello", "World!");
+
+            fileOut.delete();
+            try {
+                NbtIo.write(dataTag, new DataOutputStream(Files.newOutputStream(fileOut.toPath())));
+            } catch (IOException e) {
+                Assertions.fail("Failed to write uncompressed test tag!", e);
+            }
+            try {
+                CompoundTag readBackTag = NbtIo.read(new DataInputStream(Files.newInputStream(fileOut.toPath())));
+                Assertions.assertEquals(dataTag, readBackTag);
+            } catch (IOException e) {
+                Assertions.fail("Failed to read uncompressed test tag!", e);
+            }
+            fileOut.delete();
+
+            try {
+                NbtIo.writeCompressed(dataTag, new DataOutputStream(Files.newOutputStream(fileOut.toPath())));
+            } catch (IOException e) {
+                Assertions.fail("Failed to write compressed test tag!", e);
+            }
+            try {
+                CompoundTag readBackTag = NbtIo.readCompressed(Files.newInputStream(fileOut.toPath()));
+                Assertions.assertEquals(dataTag, readBackTag);
+            } catch (IOException e) {
+                Assertions.fail("Failed to read compressed test tag!", e);
+            }
+            fileOut.delete();
+        }
+
+        {
+            CompoundTag dataTag = new CompoundTag();
+            dataTag.put("String", new StringTag("String"));
+            dataTag.put("Byte", new ByteTag(Byte.MAX_VALUE));
+            dataTag.put("Short", new ShortTag(Short.MAX_VALUE));
+            dataTag.put("Int", new IntTag(Integer.MAX_VALUE));
+            dataTag.put("Long", new LongTag(Long.MAX_VALUE));
+            dataTag.put("Float", new FloatTag(Float.MAX_VALUE));
+            dataTag.put("Double", new DoubleTag(Double.MAX_VALUE));
+            dataTag.put("ByteArray", new ByteArrayTag(new byte[]{Byte.MIN_VALUE, 0, Byte.MAX_VALUE}));
+            dataTag.put("ShortArray", new ShortArrayTag(new short[]{Short.MIN_VALUE, 0, Short.MAX_VALUE}));
+//        tag.put("IntArray", new IntArrayTag(new int[]{Integer.MIN_VALUE, 0, Integer.MAX_VALUE}));
+            dataTag.put("LongArray", new LongArrayTag(new long[]{Long.MIN_VALUE, 0, Long.MAX_VALUE}));
+//        tag.put("FloatArray", new FloatArrayTag(new float[]{Float.NaN, Float.NEGATIVE_INFINITY, Float.MIN_VALUE, 0, Float.MAX_VALUE, Float.POSITIVE_INFINITY}));
+            dataTag.put("DoubleArray", new DoubleArrayTag(new double[]{Double.NaN, Double.NEGATIVE_INFINITY, Double.MIN_VALUE, 0, Double.MAX_VALUE, Double.POSITIVE_INFINITY}));
+
+            ListTag listTag = new ListTag();
+            listTag.addTag(new IntTag(0));
+            listTag.addTag(new IntTag(1));
+            listTag.addTag(new IntTag(2));
+            listTag.addTag(new IntTag(3));
+            listTag.addTag(new IntTag(4));
+            dataTag.put("List", listTag);
+
+
+            fileOut.delete();
+            try {
+                NbtIo.write(dataTag, new DataOutputStream(Files.newOutputStream(fileOut.toPath())));
+            } catch (IOException e) {
+                Assertions.fail("Failed to write uncompressed test tag!", e);
+            }
+            try {
+                CompoundTag readBackTag = NbtIo.read(new DataInputStream(Files.newInputStream(fileOut.toPath())));
+                Assertions.assertEquals(dataTag, readBackTag);
+            } catch (IOException e) {
+                Assertions.fail("Failed to read uncompressed test tag!", e);
+            }
+            fileOut.delete();
+
+            try {
+                NbtIo.writeCompressed(dataTag, new DataOutputStream(Files.newOutputStream(fileOut.toPath())));
+            } catch (IOException e) {
+                Assertions.fail("Failed to write compressed test tag!", e);
+            }
+            try {
+                CompoundTag readBackTag = NbtIo.readCompressed(Files.newInputStream(fileOut.toPath()));
+                Assertions.assertEquals(dataTag, readBackTag);
+            } catch (IOException e) {
+                Assertions.fail("Failed to read compressed test tag!", e);
+            }
+            fileOut.delete();
+        }
+    }
+}
diff --git a/util/nbt/src/test/java/TestShortArrayTag.java b/util/nbt/src/test/java/TestShortArrayTag.java
new file mode 100644
index 000000000..aae887f1d
--- /dev/null
+++ b/util/nbt/src/test/java/TestShortArrayTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.ShortArrayTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestShortArrayTag {
+    @Test
+    public void testTag() {
+        ShortArrayTag shortArrayTagEmpty = new ShortArrayTag();
+        Assertions.assertEquals(shortArrayTagEmpty.getId(), 11, "Tag id does not match its expected id!");
+        Assertions.assertArrayEquals(new short[0], shortArrayTagEmpty.getValue(), "Default short array tag value should be and empty array!");
+
+        ShortArrayTag shortArrayTag1 = new ShortArrayTag(new short[]{-1, 0, 2, 7, 9, Short.MIN_VALUE, 0, Short.MAX_VALUE});
+        Assertions.assertArrayEquals(new short[]{-1, 0, 2, 7, 9, Short.MIN_VALUE, 0, Short.MAX_VALUE}, shortArrayTag1.getValue(), "Tag value does not match its equivalent array!");
+
+        ShortArrayTag shortArrayTag2 = new ShortArrayTag(new short[]{-1, 0, 2, 7, 9, Short.MIN_VALUE, 0, Short.MAX_VALUE});
+        Assertions.assertEquals(shortArrayTag2, shortArrayTag1, "Tag value does not equal its equivalent tag!");
+
+        ShortArrayTag shortArrayTag3 = new ShortArrayTag(new short[]{Short.MIN_VALUE, 0, Short.MAX_VALUE, 9, 7, 2, 0, -1});
+        Assertions.assertNotEquals(shortArrayTag3, shortArrayTag2, "Tag equals non equivalent tag!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestShortTag.java b/util/nbt/src/test/java/TestShortTag.java
new file mode 100644
index 000000000..d221c82d4
--- /dev/null
+++ b/util/nbt/src/test/java/TestShortTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.ShortTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestShortTag {
+    @Test
+    public void testTag() {
+        ShortTag shortTagEmpty = new ShortTag();
+        Assertions.assertEquals(shortTagEmpty.getId(), 2, "Tag id does not match its expected id!");
+        Assertions.assertEquals(shortTagEmpty.getValue(), (short) 0, "Default short tag value should be 0!");
+
+        ShortTag shortTag1 = new ShortTag(Short.MAX_VALUE);
+        Assertions.assertEquals(Short.MAX_VALUE, shortTag1.getValue(), "Tag value does not match its equivalent value!");
+
+        ShortTag shortTag2 = new ShortTag(Short.MAX_VALUE);
+        Assertions.assertEquals(shortTag2, shortTag1, "Tag value does not equal its equivalent tag!");
+
+        ShortTag shortTag3 = new ShortTag(Short.MIN_VALUE);
+        Assertions.assertNotEquals(shortTag3, shortTag2, "Tag equals non equivalent tag!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestStringTag.java b/util/nbt/src/test/java/TestStringTag.java
new file mode 100644
index 000000000..70b7faedc
--- /dev/null
+++ b/util/nbt/src/test/java/TestStringTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.StringTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestStringTag {
+    @Test
+    public void testTag() {
+        StringTag stringTagEmpty = new StringTag();
+        Assertions.assertEquals(stringTagEmpty.getId(), 8, "Tag id does not match its expected id!");
+        Assertions.assertEquals(stringTagEmpty.getValue(), "", "Default string tag value should be \"\"!");
+
+        StringTag stringTag1 = new StringTag("Hello World!");
+        Assertions.assertEquals("Hello World!", stringTag1.getValue(), "Tag value does not match its equivalent value!");
+
+        StringTag stringTag2 = new StringTag("Hello World!");
+        Assertions.assertEquals(stringTag2, stringTag1, "Tag value does not equal its equivalent tag!");
+
+        StringTag stringTag3 = new StringTag("");
+        Assertions.assertNotEquals(stringTag3, stringTag2, "Tag equals non equivalent tag!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestTag.java b/util/nbt/src/test/java/TestTag.java
new file mode 100644
index 000000000..b66c41579
--- /dev/null
+++ b/util/nbt/src/test/java/TestTag.java
@@ -0,0 +1,97 @@
+import com.mojang.nbt.tags.ByteArrayTag;
+import com.mojang.nbt.tags.ByteTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.DoubleArrayTag;
+import com.mojang.nbt.tags.DoubleTag;
+import com.mojang.nbt.tags.EndTag;
+import com.mojang.nbt.tags.FloatTag;
+import com.mojang.nbt.tags.IntTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.LongArrayTag;
+import com.mojang.nbt.tags.LongTag;
+import com.mojang.nbt.tags.ShortArrayTag;
+import com.mojang.nbt.tags.ShortTag;
+import com.mojang.nbt.tags.StringTag;
+import com.mojang.nbt.tags.Tag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.Hashtable;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+public class TestTag {
+    @Test
+    public void testTagNames() {
+        Assertions.assertEquals("TAG_End", Tag.getTagName((byte) 0));
+        Assertions.assertEquals("TAG_Byte", Tag.getTagName((byte) 1));
+        Assertions.assertEquals("TAG_Short", Tag.getTagName((byte) 2));
+        Assertions.assertEquals("TAG_Int", Tag.getTagName((byte) 3));
+        Assertions.assertEquals("TAG_Long", Tag.getTagName((byte) 4));
+        Assertions.assertEquals("TAG_Float", Tag.getTagName((byte) 5));
+        Assertions.assertEquals("TAG_Double", Tag.getTagName((byte) 6));
+        Assertions.assertEquals("TAG_Byte_Array", Tag.getTagName((byte) 7));
+        Assertions.assertEquals("TAG_String", Tag.getTagName((byte) 8));
+        Assertions.assertEquals("TAG_List", Tag.getTagName((byte) 9));
+        Assertions.assertEquals("TAG_Compound", Tag.getTagName((byte) 10));
+        Assertions.assertEquals("TAG_Short_Array", Tag.getTagName((byte) 11));
+        Assertions.assertEquals("TAG_Double_Array", Tag.getTagName((byte) 12));
+        Assertions.assertEquals("TAG_Long_Array", Tag.getTagName((byte) 13));
+        Assertions.assertThrows(IllegalArgumentException.class, () -> Tag.getTagName((byte) - 1));
+    }
+
+    @Test
+    public void testTagTypes() {
+        Assertions.assertInstanceOf(EndTag.class, Tag.newTag((byte) 0));
+        Assertions.assertInstanceOf(ByteTag.class, Tag.newTag((byte) 1));
+        Assertions.assertInstanceOf(ShortTag.class, Tag.newTag((byte) 2));
+        Assertions.assertInstanceOf(IntTag.class, Tag.newTag((byte) 3));
+        Assertions.assertInstanceOf(LongTag.class, Tag.newTag((byte) 4));
+        Assertions.assertInstanceOf(FloatTag.class, Tag.newTag((byte) 5));
+        Assertions.assertInstanceOf(DoubleTag.class, Tag.newTag((byte) 6));
+        Assertions.assertInstanceOf(ByteArrayTag.class, Tag.newTag((byte) 7));
+        Assertions.assertInstanceOf(StringTag.class, Tag.newTag((byte) 8));
+        Assertions.assertInstanceOf(ListTag.class, Tag.newTag((byte) 9));
+        Assertions.assertInstanceOf(CompoundTag.class, Tag.newTag((byte) 10));
+        Assertions.assertInstanceOf(ShortArrayTag.class, Tag.newTag((byte) 11));
+        Assertions.assertInstanceOf(DoubleArrayTag.class, Tag.newTag((byte) 12));
+        Assertions.assertInstanceOf(LongArrayTag.class, Tag.newTag((byte) 13));
+        Assertions.assertThrows(IllegalArgumentException.class, () -> Tag.newTag((byte) - 1));
+    }
+
+    @Test
+    public void testTagGenerics() {
+        Assertions.assertInstanceOf(ByteTag.class, Tag.createTagOfType(byte.class));
+        Assertions.assertInstanceOf(ByteTag.class, Tag.createTagOfType(Byte.class));
+        Assertions.assertInstanceOf(ShortTag.class, Tag.createTagOfType(short.class));
+        Assertions.assertInstanceOf(ShortTag.class, Tag.createTagOfType(Short.class));
+        Assertions.assertInstanceOf(IntTag.class, Tag.createTagOfType(int.class));
+        Assertions.assertInstanceOf(IntTag.class, Tag.createTagOfType(Integer.class));
+        Assertions.assertInstanceOf(LongTag.class, Tag.createTagOfType(long.class));
+        Assertions.assertInstanceOf(LongTag.class, Tag.createTagOfType(Long.class));
+        Assertions.assertInstanceOf(FloatTag.class, Tag.createTagOfType(float.class));
+        Assertions.assertInstanceOf(FloatTag.class, Tag.createTagOfType(Float.class));
+        Assertions.assertInstanceOf(DoubleTag.class, Tag.createTagOfType(double.class));
+        Assertions.assertInstanceOf(DoubleTag.class, Tag.createTagOfType(Double.class));
+        Assertions.assertInstanceOf(ByteArrayTag.class, Tag.createTagOfType(byte[].class));
+        Assertions.assertInstanceOf(ByteArrayTag.class, Tag.createTagOfType(Byte[].class));
+        Assertions.assertInstanceOf(StringTag.class, Tag.createTagOfType(String.class));
+        Assertions.assertInstanceOf(ListTag.class, Tag.createTagOfType(List.class));
+        Assertions.assertInstanceOf(ListTag.class, Tag.createTagOfType(ArrayList.class));
+        Assertions.assertInstanceOf(ListTag.class, Tag.createTagOfType(LinkedList.class));
+        Assertions.assertInstanceOf(CompoundTag.class, Tag.createTagOfType(Map.class));
+        Assertions.assertInstanceOf(CompoundTag.class, Tag.createTagOfType(HashMap.class));
+        Assertions.assertInstanceOf(CompoundTag.class, Tag.createTagOfType(Hashtable.class));
+        Assertions.assertInstanceOf(ShortArrayTag.class, Tag.createTagOfType(short[].class));
+        Assertions.assertInstanceOf(ShortArrayTag.class, Tag.createTagOfType(Short[].class));
+        Assertions.assertInstanceOf(DoubleArrayTag.class, Tag.createTagOfType(double[].class));
+        Assertions.assertInstanceOf(DoubleArrayTag.class, Tag.createTagOfType(Double[].class));
+        Assertions.assertInstanceOf(LongArrayTag.class, Tag.createTagOfType(long[].class));
+        Assertions.assertInstanceOf(LongArrayTag.class, Tag.createTagOfType(Long[].class));
+        Assertions.assertThrows(IllegalArgumentException.class, () -> Tag.createTagOfType(Thread.class));
+        Assertions.assertThrows(IllegalArgumentException.class, () -> Tag.createTagOfType(Thread[].class));
+    }
+}
diff --git a/util/seed-viewer/build.gradle.kts b/util/seed-viewer/build.gradle.kts
index d901f9c79..460853a3b 100644
--- a/util/seed-viewer/build.gradle.kts
+++ b/util/seed-viewer/build.gradle.kts
@@ -21,6 +21,8 @@ dependencies {
     testImplementation("org.junit.jupiter:junit-jupiter")
 
     implementation(project(":game:core"))?.let { include(it) }
+    implementation(project(":util:logging"))?.let { include(it) }
+    implementation(project(":util:nbt"))?.let { include(it) }
 
     implementation(libs.jetbrains.annotations)?.let { include(it) }
     implementation(libs.bundles.log4j)?.let { include(it) }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java
index c46feaf47..4bb459ef5 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java
@@ -10,7 +10,6 @@ import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import org.slf4j.Logger;
 
-import java.io.IOException;
 import java.util.Arrays;
 
 public class ChunkProviderSeedViewer
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
index 5712fabc2..91030b157 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
@@ -1,7 +1,7 @@
 package org.useless.seedviewer.bta.worldloader;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java
index cb7a5026c..cc8069d74 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/DimensionDataLoader.java
@@ -1,7 +1,7 @@
 package org.useless.seedviewer.bta.worldloader;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.save.DimensionData;
 import org.jetbrains.annotations.NotNull;
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
index 991d09397..a80c5f5c5 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/LevelDataLoader.java
@@ -1,7 +1,7 @@
 package org.useless.seedviewer.bta.worldloader;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.save.LevelData;
 import org.jetbrains.annotations.NotNull;
